const { getAddresseId } = require("../../db/mail");
const { generateAttrs, generateUsers } = require("../test-utils/test-attrsUtils");
const { registerMessageInApp, roomType } = require("../../mails/saveMessage");

jest.mock("../../db/mail");

// todo mock db

describe("saveMessage", () => {
    describe("is not a reply", () => {
        it("first DM from user should create a DM room", async () => {
            const users = generateUsers(2);
            const attrs = generateAttrs({ from: [users[0].user], to: [users[1].user] });

            getAddresseId.mockReturnValue(users[1].id);

            const register = new registerMessageInApp(1, attrs, 1);
            register.ownerId = users[0].id;

            jest.spyOn(register, "isFromUs").mockReturnValue(true);
            jest.spyOn(register, "init").mockReturnValue("");
            
            const createOrRegisterOnExistence = jest
                .spyOn(register, "createOrRegisterOnExistence")
                .mockImplementation(() => undefined);

            await register.save();

            expect(createOrRegisterOnExistence).toHaveBeenCalledWith(users[1].id, roomType.DM);
        });
        // it("DM message from user should be added to DM room", async () => {

        // });
        // it("first GROUP message should create a group", () => {});
    });
    describe("replies", () => {
        it("", () => {});
    });
    describe("", () => {});
});
